/*===========================================================================*/
/*   (Engine/compiler.scm)                                                   */
/*   Bigloo (2.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 10 14:28:09 CEST 2003       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.96 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6a -unsafev -no-hello -O2 -rm -unsafe -s -indent Engine/compiler.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_ccompz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_producerz00;
   obj_t BgL_consumerz00;
   obj_t BgL_finaliza7erza7;
} *BgL_ccompz00_bglt;


extern obj_t BGl_coercezd2walkz12zc0zzcoerce_walkz00(obj_t);
extern obj_t BGl_loadzd2libraryzd2initz00zzinit_setrcz00();
static obj_t BGl_zc3anonymousza32936ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33036ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00;
extern obj_t BGl_modulezd2checksumzd2objectz00zzmodule_modulez00();
BGL_IMPORT double BGl_roundflz00zz__r4_numbers_6_5_flonumz00(double);
static obj_t BGl_methodzd2initzd2zzengine_compilerz00();
extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
BGL_IMPORT obj_t open_input_string(obj_t);
extern obj_t BGl_ldz00zzcc_ldz00(obj_t, bool_t);
extern obj_t BGl_bdbzd2walkz12zc0zzbdb_walkz00(obj_t);
static obj_t BGl_zc3anonymousza32944ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33044ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_installzd2compilerzd2signalsz12z12zzengine_signalsz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_zc3anonymousza33049ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_userzd2walkzd2zzuser_userz00(obj_t);
static obj_t BGl_zc3anonymousza32952ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_buildzd2astzd2zzast_buildz00(obj_t);
extern obj_t BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();
extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
BGL_IMPORT obj_t string_to_bstring(char *);
extern obj_t BGl_integratezd2walkz12zc0zzintegrate_walkz00(obj_t);
static obj_t BGl_zc3anonymousza33059ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32961ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
extern obj_t BGl_installzd2typezd2cachez12z12zztype_cachez00();
extern obj_t BGl_failzd2walkz12zc0zzfail_walkz00(obj_t);
extern obj_t BGl_bdbzd2settingz12zc0zzbdb_settingz00();
extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
static obj_t BGl_zc3anonymousza32969ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33069ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl__cczd2compilerzd2zzengine_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl_installzd2initialzd2expanderz00zzexpand_installz00();
extern obj_t BGl_expandzd2unitszd2zzexpand_epsz00(obj_t);
extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
static obj_t BGl_cnstzd2initzd2zzengine_compilerz00();
static obj_t BGl_zc3anonymousza32837ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33074ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(obj_t, obj_t);
extern obj_t BGl_producezd2modulez12zc0zzmodule_modulez00(obj_t);
extern obj_t BGl_readzd2accesszd2filez00zzread_accessz00();
static obj_t BGl_zc3anonymousza32978ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_writezd2astzd2zzwrite_astz00(obj_t);
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
static obj_t BGl_zc3anonymousza33079ze3z83zzengine_compilerz00(obj_t);
BGL_IMPORT obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_hellozd2worldzd2zzengine_enginez00();
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
extern obj_t BGl_makezd2profzd2unitz00zzprof_walkz00();
static obj_t BGl_importedzd2moduleszd2initz00zzengine_compilerz00();
static obj_t BGl_zc3anonymousza32846ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_cnstzd2walkz12zc0zzcnst_walkz00(obj_t);
extern obj_t BGl_cgenzd2walkzd2zzcgen_walkz00(obj_t);
static obj_t BGl_zc3anonymousza33087ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32852ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32989ze3z83zzengine_compilerz00(obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
static obj_t BGl_zc3anonymousza33092ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_writezd2expandedzd2zzwrite_expandedz00(obj_t);
extern obj_t BGl_globaliza7ezd2walkz12z67zzglobaliza7e_walkza7(obj_t, obj_t);
extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
static obj_t BGl_toplevelzd2initzd2zzengine_compilerz00();
static obj_t BGl_zc3anonymousza32860ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_dotnetzd2ldzd2zzdotnet_ldz00();
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_compilerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_signalsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_srcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzwrite_expandedz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzwrite_astz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_accessz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzheap_makez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_checkzd2sharingzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_unitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_checkzd2globalzd2initz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzuser_userz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzmodule_includez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_epsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzexpand_installz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinit_setrcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzeffect_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcallcc_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzfail_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzglobaliza7e_walkza7(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcfa_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzintegrate_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcnst_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcgen_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzhgen_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_settingz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_spreadzd2objzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbdb_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzprof_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_indentz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_ccz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzcc_ldz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_ldz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzdotnet_dotnetz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzdotnet_ldz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
static obj_t BGl_zc3anonymousza32999ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza32866ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza33113ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_stopzd2onzd2passz00zzengine_passz00(obj_t, obj_t);
extern obj_t BGl_effectzd2walkz12zc0zzeffect_walkz00(obj_t);
extern obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t);
extern obj_t BGl_checkzd2globalzd2initializa7ationza7zzast_checkzd2globalzd2initz00();
extern obj_t BGl_readzd2jfilezd2zzread_jvmz00();
BGL_EXPORTED_DECL obj_t BGl_cczd2compilerzd2zzengine_compilerz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32875ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_checkzd2typeszd2zztype_envz00();
extern obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
extern obj_t BGl_cfazd2walkz12zc0zzcfa_walkz00(obj_t);
extern obj_t BGl_jvmzd2dumpzd2zzjvm_jdumpz00(obj_t);
extern obj_t BGl_setzd2defaultzd2typez12z12zztype_cachez00(BgL_typez00_bglt);
extern obj_t BGl_makezd2addzd2heapz00zzheap_makez00();
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_bdbzd2spreadzd2objz12z12zzbdb_spreadzd2objzd2(obj_t);
extern obj_t BGl_enginez00zzengine_enginez00();
extern obj_t BGl_restorezd2heapzd2zzheap_restorez00();
extern obj_t BGl_getzd2toplevelzd2unitz00zzmodule_includez00();
static obj_t BGl_zc3anonymousza32748ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2optimza2z00zzengine_paramz00;
extern obj_t BGl_za2heapzd2debugza2zd2zzengine_paramz00;
BGL_EXPORTED_DECL obj_t BGl_compilerz00zzengine_compilerz00();
static obj_t BGl_zc3anonymousza32891ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
extern obj_t BGl_inlinezd2walkz12zc0zzinline_walkz00(obj_t, obj_t);
BGL_IMPORT obj_t display_string(obj_t, obj_t);
extern obj_t BGl_za2passza2z00zzengine_paramz00;
extern obj_t BGl_jvmzd2ldzd2zzjvm_ldz00();
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_patchzd2vectorzd2setz12z12zzcfa_tvectorz00();
static obj_t BGl_zc3anonymousza33006ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(obj_t, obj_t);
static obj_t BGl_zc3anonymousza32761ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32907ze3z83zzengine_compilerz00(obj_t);
static obj_t BGl_zc3anonymousza32899ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_makezd2heapzd2zzheap_makez00();
extern obj_t BGl_za2interpreterza2z00zzengine_paramz00;
extern obj_t BGl_za2restzd2argsza2zd2zzengine_paramz00;
static obj_t BGl_zc3anonymousza33016ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_za2objza2z00zztype_cachez00;
extern obj_t BGl_astzb2initializa7ersz15zzcgen_walkz00(obj_t);
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
extern obj_t BGl_indentz00zzcc_indentz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzengine_compilerz00 = BUNSPEC;
extern obj_t BGl_za2modulezd2checksumzd2objectzf3za2zf3zzengine_paramz00;
static obj_t BGl_zc3anonymousza32924ze3z83zzengine_compilerz00(obj_t);
extern obj_t BGl_callcczd2walkz12zc0zzcallcc_walkz00(obj_t);
static obj_t BGl_zc3anonymousza33026ze3z83zzengine_compilerz00(obj_t);
BGL_IMPORT obj_t BGl_za2warningza2z00zz__errorz00;
extern obj_t BGl_za2profilezd2modeza2zd2zzengine_paramz00;
extern obj_t BGl_za2czd2debugza2zd2zzengine_paramz00;
static obj_t BGl_libraryzd2moduleszd2initz00zzengine_compilerz00();
extern obj_t BGl_readzd2srczd2zzread_srcz00();
extern obj_t BGl_exitzd2bigloozd2zzinit_mainz00(obj_t);
extern obj_t BGl_ccz00zzcc_ccz00(obj_t, obj_t, bool_t);
extern obj_t BGl_dotnetz00zzdotnet_dotnetz00(obj_t);
static obj_t BGl__compilerz00zzengine_compilerz00(obj_t);
static obj_t __cnst[ 43 ] ;


DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2envzd2zzengine_compilerz00, BgL_bgl__compilerza700za7za7engine_compilerza7003858z00, BGl__compilerz00zzengine_compilerz00, 0L, 0 );
extern obj_t BGl_hgenzd2walkzd2envz00zzhgen_walkz00;
DEFINE_EXPORT_PROCEDURE( BGl_cczd2compilerzd2envz00zzengine_compilerz00, BgL_bgl__ccza7d2compilerza7d2za7za7engine_compilerza7003859za7, BGl__cczd2compilerzd2zzengine_compilerz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3801z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32860za7e3za783za7za7engine_compilerza7003860za7, BGl_zc3anonymousza32860ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3802z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32866za7e3za783za7za7engine_compilerza7003861za7, BGl_zc3anonymousza32866ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3795z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32748za7e3za783za7za7engine_compilerza7003862za7, BGl_zc3anonymousza32748ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3796z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a32761za7e3za783za7za7engine_compilerza7003863za7, BGl_zc3anonymousza32761ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3817z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33044za7e3za783za7za7engine_compilerza7003864za7, BGl_zc3anonymousza33044ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3818z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33049za7e3za783za7za7engine_compilerza7003865za7, BGl_zc3anonymousza33049ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3820z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33069za7e3za783za7za7engine_compilerza7003866za7, BGl_zc3anonymousza33069ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3819z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33059za7e3za783za7za7engine_compilerza7003867za7, BGl_zc3anonymousza33059ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STRING( BGl_string3828z00zzengine_compilerz00, BgL_bgl_string3828za700za7za7engine_compilerza7003868z00, "done il .net jast jvmas cc jvm cindent distrib cgen c reduce+ effect+ inline+ reducer cnst bdb reduce coerce integrate cfa globalize globalization fail trace inline all effect callcc (jvm .net) bdb-spread-obj make-add-heap make-heap ast expand user hgen (pragma::int \"bdb_release_lock()\") *debug* set! (#unspecified) mco dump-heap ", 331 );
DEFINE_STATIC_PROCEDURE( BGl_proc3821z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33074za7e3za783za7za7engine_compilerza7003869za7, BGl_zc3anonymousza33074ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3822z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33079za7e3za783za7za7engine_compilerza7003870za7, BGl_zc3anonymousza33079ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STRING( BGl_string3826z00zzengine_compilerz00, BgL_bgl_string3826za700za7za7engine_compilerza7003871z00, "Unimplemented target language", 29 );
DEFINE_STATIC_PROCEDURE( BGl_proc3823z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33087za7e3za783za7za7engine_compilerza7003872za7, BGl_zc3anonymousza33087ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STRING( BGl_string3825z00zzengine_compilerz00, BgL_bgl_string3825za700za7za7engine_compilerza7003873z00, "compiler", 8 );
DEFINE_STATIC_PROCEDURE( BGl_proc3824z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33092za7e3za783za7za7engine_compilerza7003874za7, BGl_zc3anonymousza33092ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3827z00zzengine_compilerz00, BgL_bgl_za7c3anonymousza7a33113za7e3za783za7za7engine_compilerza7003875za7, BGl_zc3anonymousza33113ze3z83zzengine_compilerz00, 0L, 0 );
DEFINE_STRING( BGl_string3816z00zzengine_compilerz00, BgL_bgl_string3816za700za7za7engine_compilerza7003876z00, "reduce+", 7 );
DEFINE_STRING( BGl_string3815z00zzengine_compilerz00, BgL_bgl_string3815za700za7za7engine_compilerza7003877z00, "init", 4 );
DEFINE_STRING( BGl_string3814z00zzengine_compilerz00, BgL_bgl_string3814za700za7za7engine_compilerza7003878z00, "inline+", 7 );
DEFINE_STRING( BGl_string3813z00zzengine_compilerz00, BgL_bgl_string3813za700za7za7engine_compilerza7003879z00, "cnst", 4 );
DEFINE_STRING( BGl_string3812z00zzengine_compilerz00, BgL_bgl_string3812za700za7za7engine_compilerza7003880z00, "reduce", 6 );
DEFINE_STRING( BGl_string3811z00zzengine_compilerz00, BgL_bgl_string3811za700za7za7engine_compilerza7003881z00, "coerce", 6 );
DEFINE_STRING( BGl_string3810z00zzengine_compilerz00, BgL_bgl_string3810za700za7za7engine_compilerza7003882z00, "integrate", 9 );
DEFINE_STRING( BGl_string3809z00zzengine_compilerz00, BgL_bgl_string3809za700za7za7engine_compilerza7003883z00, "cfa", 3 );
DEFINE_STRING( BGl_string3799z00zzengine_compilerz00, BgL_bgl_string3799za700za7za7engine_compilerza7003884z00, "failure during postlude hook", 28 );
DEFINE_STRING( BGl_string3808z00zzengine_compilerz00, BgL_bgl_string3808za700za7za7engine_compilerza7003885z00, "globalize", 9 );
DEFINE_STRING( BGl_string3798z00zzengine_compilerz00, BgL_bgl_string3798za700za7za7engine_compilerza7003886z00, " occured, ending ...", 20 );
DEFINE_STRING( BGl_string3807z00zzengine_compilerz00, BgL_bgl_string3807za700za7za7engine_compilerza7003887z00, "fail", 4 );
DEFINE_STRING( BGl_string3797z00zzengine_compilerz00, BgL_bgl_string3797za700za7za7engine_compilerza7003888z00, " error", 6 );
DEFINE_STRING( BGl_string3806z00zzengine_compilerz00, BgL_bgl_string3806za700za7za7engine_compilerza7003889z00, "inline", 6 );
DEFINE_STRING( BGl_string3805z00zzengine_compilerz00, BgL_bgl_string3805za700za7za7engine_compilerza7003890z00, "effect", 6 );
DEFINE_STRING( BGl_string3804z00zzengine_compilerz00, BgL_bgl_string3804za700za7za7engine_compilerza7003891z00, "callcc", 6 );
DEFINE_STRING( BGl_string3794z00zzengine_compilerz00, BgL_bgl_string3794za700za7za7engine_compilerza7003892z00, "Don't know what to do with arguments: ", 38 );
DEFINE_STRING( BGl_string3803z00zzengine_compilerz00, BgL_bgl_string3803za700za7za7engine_compilerza7003893z00, "trace", 5 );
DEFINE_STRING( BGl_string3793z00zzengine_compilerz00, BgL_bgl_string3793za700za7za7engine_compilerza7003894z00, "Illegal source file", 19 );
DEFINE_STRING( BGl_string3792z00zzengine_compilerz00, BgL_bgl_string3792za700za7za7engine_compilerza7003895z00, "Parse error", 11 );
DEFINE_STRING( BGl_string3800z00zzengine_compilerz00, BgL_bgl_string3800za700za7za7engine_compilerza7003896z00, "ast", 3 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_compilerz00(long BgL_checksumz00_2202, char * BgL_fromz00_2203)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzengine_compilerz00))
{ 
BGl_requirezd2initializa7ationz75zzengine_compilerz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzengine_compilerz00(); 
BGl_cnstzd2initzd2zzengine_compilerz00(); 
BGl_importedzd2moduleszd2initz00zzengine_compilerz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "engine_compiler"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_cportz00_2195;
BgL_cportz00_2195 = 
open_input_string(BGl_string3828z00zzengine_compilerz00); 
{ 
long BgL_iz00_2196;
BgL_iz00_2196 = ((long)42); 
BgL_loopz00_2197:
{ /* ./Engine/compiler.scm 15 */
bool_t BgL_test3830z00_2198;
BgL_test3830z00_2198 = 
(BgL_iz00_2196==((long)-1)); 
if(BgL_test3830z00_2198)
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;}  else 
{ /* ./Engine/compiler.scm 15 */
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_arg3832z00_2199;
{ /* ./Engine/compiler.scm 15 */
obj_t BgL_list3835z00_2200;
BgL_list3835z00_2200 = 
MAKE_PAIR(BgL_cportz00_2195, BNIL); 
BgL_arg3832z00_2199 = 
BGl_readz00zz__readerz00(BgL_list3835z00_2200); } 
{ /* ./Engine/compiler.scm 15 */
int BgL_auxz00_2221;
BgL_auxz00_2221 = 
(int)(BgL_iz00_2196); 
CNST_TABLE_SET(BgL_auxz00_2221, BgL_arg3832z00_2199); } } 
{ /* ./Engine/compiler.scm 15 */
int BgL_auxz00_2201;
{ /* ./Engine/compiler.scm 15 */
long BgL_auxz00_2224;
BgL_auxz00_2224 = 
(BgL_iz00_2196-((long)1)); 
BgL_auxz00_2201 = 
(int)(BgL_auxz00_2224); } 
{ 
long BgL_iz00_2227;
BgL_iz00_2227 = 
(long)(BgL_auxz00_2201); 
BgL_iz00_2196 = BgL_iz00_2227; 
goto BgL_loopz00_2197;} } } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;} 
}



/* compiler */
BGL_EXPORTED_DEF obj_t BGl_compilerz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 78 */
BGl_installzd2compilerzd2signalsz12z12zzengine_signalsz00(); 
{ /* ./Engine/compiler.scm 84 */
obj_t BgL_srcz00_926;
BgL_srcz00_926 = 
BGl_readzd2srczd2zzread_srcz00(); 
if(
CBOOL(BgL_srcz00_926))
{ /* ./Engine/compiler.scm 92 */
bool_t BgL_test2716z00_927;
BgL_test2716z00_927 = 
PAIRP(BgL_srcz00_926); 
if(BgL_test2716z00_927)
{ /* ./Engine/compiler.scm 92 */BFALSE; }  else 
{ /* ./Engine/compiler.scm 92 */
BGl_userzd2errorzd2zztools_errorz00(BGl_string3792z00zzengine_compilerz00, BGl_string3793z00zzengine_compilerz00, BgL_srcz00_926, BNIL); } }  else 
{ /* ./Engine/compiler.scm 89 */
BGl_za2interpreterza2z00zzengine_paramz00 = BTRUE; 
{ /* ./Engine/compiler.scm 91 */
obj_t BgL_arg2721z00_929;
BgL_arg2721z00_929 = 
BGl_enginez00zzengine_enginez00(); 
BGl_exitzd2bigloozd2zzinit_mainz00(BgL_arg2721z00_929); } } 
BGl_hellozd2worldzd2zzengine_enginez00(); 
{ /* ./Engine/compiler.scm 99 */
bool_t BgL_test2725z00_930;
{ /* ./Engine/compiler.scm 99 */
long BgL_n1z00_1544;
BgL_n1z00_1544 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test2725z00_930 = 
(BgL_n1z00_1544>((long)0)); } 
if(BgL_test2725z00_930)
{ /* ./Engine/compiler.scm 99 */
BGl_bdbzd2settingz12zc0zzbdb_settingz00(); }  else 
{ /* ./Engine/compiler.scm 99 */BFALSE; } } 
{ /* ./Engine/compiler.scm 103 */
bool_t BgL_test2728z00_931;
{ /* ./Engine/compiler.scm 103 */
obj_t BgL_objz00_1546;
BgL_objz00_1546 = BGl_za2restzd2argsza2zd2zzengine_paramz00; 
BgL_test2728z00_931 = 
NULLP(BgL_objz00_1546); } 
if(BgL_test2728z00_931)
{ /* ./Engine/compiler.scm 103 */BFALSE; }  else 
{ /* ./Engine/compiler.scm 104 */
obj_t BgL_list2730z00_932;
{ /* ./Engine/compiler.scm 104 */
obj_t BgL_arg2733z00_934;
BgL_arg2733z00_934 = 
MAKE_PAIR(BGl_za2restzd2argsza2zd2zzengine_paramz00, BNIL); 
BgL_list2730z00_932 = 
MAKE_PAIR(BGl_string3794z00zzengine_compilerz00, BgL_arg2733z00_934); } 
BGl_warningz00zz__errorz00(BgL_list2730z00_932); } } 
BGl_readzd2accesszd2filez00zzread_accessz00(); 
BGl_readzd2jfilezd2zzread_jvmz00(); 
if(
CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
{ /* ./Engine/compiler.scm 111 */
BGl_initializa7ezd2Genvz12z67zzast_envz00(); 
BGl_initializa7ezd2Tenvz12z67zztype_envz00(); }  else 
{ /* ./Engine/compiler.scm 111 */
BGl_restorezd2heapzd2zzheap_restorez00(); } 
BGl_installzd2typezd2cachez12z12zztype_cachez00(); 
BGl_patchzd2vectorzd2setz12z12zzcfa_tvectorz00(); 
{ /* ./Engine/compiler.scm 127 */
obj_t BgL_modulez00_935;
BgL_modulez00_935 = 
CAR(BgL_srcz00_926); 
{ /* ./Engine/compiler.scm 127 */
obj_t BgL_srczd2codezd2_936;
BgL_srczd2codezd2_936 = 
CDR(BgL_srcz00_926); 
{ /* ./Engine/compiler.scm 128 */
obj_t BgL_unitsz00_937;
{ /* ./Engine/compiler.scm 129 */
obj_t BgL_cellvalz00_2259;
BgL_cellvalz00_2259 = 
BGl_producezd2modulez12zc0zzmodule_modulez00(BgL_modulez00_935); 
BgL_unitsz00_937 = 
MAKE_CELL(BgL_cellvalz00_2259); } 
{ /* ./Engine/compiler.scm 129 */

{ /* ./Engine/compiler.scm 131 */
obj_t BgL_arg2745z00_938;
BgL_arg2745z00_938 = 
CNST_TABLE_REF(((long)0)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2745z00_938, BGl_proc3795z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 134 */
bool_t BgL_test2750z00_942;
{ /* ./Engine/compiler.scm 134 */
long BgL_n1z00_1549;
BgL_n1z00_1549 = 
(long)CINT(BGl_za2profilezd2modeza2zd2zzengine_paramz00); 
BgL_test2750z00_942 = 
(BgL_n1z00_1549>=((long)1)); } 
if(BgL_test2750z00_942)
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_auxz00_2170;
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_arg2752z00_943;
BgL_arg2752z00_943 = 
BGl_makezd2profzd2unitz00zzprof_walkz00(); 
{ /* ./Engine/compiler.scm 135 */
obj_t BgL_auxz00_2267;
BgL_auxz00_2267 = 
CELL_REF(BgL_unitsz00_937); 
BgL_auxz00_2170 = 
MAKE_PAIR(BgL_arg2752z00_943, BgL_auxz00_2267); } } 
CELL_SET(BgL_unitsz00_937, BgL_auxz00_2170); }  else 
{ /* ./Engine/compiler.scm 134 */BFALSE; } } 
if(
CBOOL(BGl_za2modulezd2checksumzd2objectzf3za2zf3zzengine_paramz00))
{ /* ./Engine/compiler.scm 138 */
BGl_modulezd2checksumzd2objectz00zzmodule_modulez00(); }  else 
{ /* ./Engine/compiler.scm 138 */BFALSE; } 
{ /* ./Engine/compiler.scm 140 */
obj_t BgL_arg2758z00_944;
BgL_arg2758z00_944 = 
CNST_TABLE_REF(((long)1)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2758z00_944, BGl_proc3796z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 143 */
obj_t BgL_code0z00_948;
if(
NULLP(BgL_srczd2codezd2_936))
{ /* ./Engine/compiler.scm 143 */
BgL_code0z00_948 = 
CNST_TABLE_REF(((long)2)); }  else 
{ /* ./Engine/compiler.scm 143 */
BgL_code0z00_948 = BgL_srczd2codezd2_936; } 
{ /* ./Engine/compiler.scm 143 */
obj_t BgL_code1z00_949;
{ /* ./Engine/compiler.scm 144 */
bool_t BgL_test2771z00_954;
{ /* ./Engine/compiler.scm 144 */
bool_t BgL_test2784z00_960;
{ /* ./Engine/compiler.scm 144 */
obj_t BgL_objz00_1552;
BgL_objz00_1552 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2784z00_960 = 
INTEGERP(BgL_objz00_1552); } 
if(BgL_test2784z00_960)
{ /* ./Engine/compiler.scm 145 */
long BgL_n1z00_1553;
BgL_n1z00_1553 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2771z00_954 = 
(BgL_n1z00_1553>=((long)3)); }  else 
{ /* ./Engine/compiler.scm 144 */
BgL_test2771z00_954 = ((bool_t)0); } } 
if(BgL_test2771z00_954)
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2773z00_955;
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2776z00_956;obj_t BgL_arg2777z00_957;
BgL_arg2776z00_956 = 
CNST_TABLE_REF(((long)3)); 
{ /* ./Engine/compiler.scm 146 */
obj_t BgL_arg2780z00_958;obj_t BgL_arg2781z00_959;
BgL_arg2780z00_958 = 
CNST_TABLE_REF(((long)4)); 
BgL_arg2781z00_959 = 
MAKE_PAIR(BGl_za2compilerzd2debugza2zd2zzengine_paramz00, BNIL); 
BgL_arg2777z00_957 = 
MAKE_PAIR(BgL_arg2780z00_958, BgL_arg2781z00_959); } 
BgL_arg2773z00_955 = 
MAKE_PAIR(BgL_arg2776z00_956, BgL_arg2777z00_957); } 
BgL_code1z00_949 = 
MAKE_PAIR(BgL_arg2773z00_955, BgL_code0z00_948); }  else 
{ /* ./Engine/compiler.scm 144 */
BgL_code1z00_949 = BgL_code0z00_948; } } 
{ /* ./Engine/compiler.scm 144 */
obj_t BgL_code2z00_950;
{ /* ./Engine/compiler.scm 148 */
bool_t BgL_test2766z00_952;
{ /* ./Engine/compiler.scm 148 */
bool_t BgL_test2768z00_953;
{ /* ./Engine/compiler.scm 148 */
obj_t BgL_objz00_1555;
BgL_objz00_1555 = BGl_za2heapzd2debugza2zd2zzengine_paramz00; 
BgL_test2768z00_953 = 
INTEGERP(BgL_objz00_1555); } 
if(BgL_test2768z00_953)
{ /* ./Engine/compiler.scm 148 */
long BgL_n1z00_1556;
BgL_n1z00_1556 = 
(long)CINT(BGl_za2heapzd2debugza2zd2zzengine_paramz00); 
BgL_test2766z00_952 = 
(BgL_n1z00_1556>=((long)1)); }  else 
{ /* ./Engine/compiler.scm 148 */
BgL_test2766z00_952 = ((bool_t)0); } } 
if(BgL_test2766z00_952)
{ /* ./Engine/compiler.scm 153 */
obj_t BgL_auxz00_2293;
BgL_auxz00_2293 = 
CNST_TABLE_REF(((long)5)); 
BgL_code2z00_950 = 
MAKE_PAIR(BgL_auxz00_2293, BgL_code1z00_949); }  else 
{ /* ./Engine/compiler.scm 148 */
BgL_code2z00_950 = BgL_code1z00_949; } } 
{ /* ./Engine/compiler.scm 148 */

{ /* ./Engine/compiler.scm 155 */
obj_t BgL_arg2763z00_951;
BgL_arg2763z00_951 = 
BGl_getzd2toplevelzd2unitz00zzmodule_includez00(); 
BGl_unitzd2sexpza2zd2addz12zb0zzast_unitz00(BgL_arg2763z00_951, BgL_code2z00_950); } } } } } 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2789z00_963;
{ /* ./Engine/compiler.scm 158 */
long BgL_n1z00_1558;
BgL_n1z00_1558 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_test2789z00_963 = 
(BgL_n1z00_1558>((long)0)); } 
if(BgL_test2789z00_963)
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_port2677z00_964;
BgL_port2677z00_964 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_port2677z00_964); 
display_string(BGl_string3797z00zzengine_compilerz00, BgL_port2677z00_964); 
{ /* ./Engine/compiler.scm 158 */
char * BgL_arg2793z00_965;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2795z00_966;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2796z00_967;
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_res3581z00_1566;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_objz00_1560;
BgL_objz00_1560 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test1397z00_1561;
BgL_test1397z00_1561 = 
INTEGERP(BgL_objz00_1560); 
if(BgL_test1397z00_1561)
{ /* ./Engine/compiler.scm 158 */
BgL_res3581z00_1566 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test1398z00_1562;
BgL_test1398z00_1562 = 
REALP(BgL_objz00_1560); 
if(BgL_test1398z00_1562)
{ /* ./Engine/compiler.scm 158 */
double BgL_arg1400z00_1563;
BgL_arg1400z00_1563 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
REAL_TO_DOUBLE(BgL_objz00_1560)); 
{ /* ./Engine/compiler.scm 158 */
double BgL_auxz00_2310;
BgL_auxz00_2310 = 
REAL_TO_DOUBLE(BgL_objz00_1560); 
BgL_res3581z00_1566 = 
(BgL_auxz00_2310==BgL_arg1400z00_1563); } }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_res3581z00_1566 = ((bool_t)0); } } } } 
BgL_test2796z00_967 = BgL_res3581z00_1566; } 
if(BgL_test2796z00_967)
{ /* ./Engine/compiler.scm 158 */
BgL_test2795z00_966 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1))); }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_test2795z00_966 = ((bool_t)0); } } 
if(BgL_test2795z00_966)
{ /* ./Engine/compiler.scm 158 */
BgL_arg2793z00_965 = "s"; }  else 
{ /* ./Engine/compiler.scm 158 */
BgL_arg2793z00_965 = ""; } } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(
string_to_bstring(BgL_arg2793z00_965), BgL_port2677z00_964); } 
display_string(BGl_string3798z00zzengine_compilerz00, BgL_port2677z00_964); 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2677z00_964); } 
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_list2803z00_968;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_auxz00_2321;
BgL_auxz00_2321 = 
BINT(((long)-1)); 
BgL_list2803z00_968 = 
MAKE_PAIR(BgL_auxz00_2321, BNIL); } 
BGl_exitz00zz__errorz00(BgL_list2803z00_968); } }  else 
{ 
obj_t BgL_hooksz00_969;obj_t BgL_hnamesz00_970;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2806z00_972;
BgL_arg2806z00_972 = BNIL; 
BgL_hooksz00_969 = BgL_arg2806z00_972; 
BgL_hnamesz00_970 = BNIL; 
BgL_loopz00_971:
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2811z00_975;
BgL_test2811z00_975 = 
NULLP(BgL_hooksz00_969); 
if(BgL_test2811z00_975)
{ /* ./Engine/compiler.scm 158 */BUNSPEC; }  else 
{ /* ./Engine/compiler.scm 158 */
bool_t BgL_test2812z00_976;
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_fun2826z00_981;
BgL_fun2826z00_981 = 
CAR(BgL_hooksz00_969); 
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_auxz00_2328;
BgL_auxz00_2328 = 
PROCEDURE_ENTRY(BgL_fun2826z00_981)(BgL_fun2826z00_981, BEOA); 
BgL_test2812z00_976 = 
CBOOL(BgL_auxz00_2328); } } 
if(BgL_test2812z00_976)
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2814z00_977;obj_t BgL_arg2815z00_978;
BgL_arg2814z00_977 = 
CDR(BgL_hooksz00_969); 
BgL_arg2815z00_978 = 
CDR(BgL_hnamesz00_970); 
{ 
obj_t BgL_hnamesz00_2336;obj_t BgL_hooksz00_2335;
BgL_hooksz00_2335 = BgL_arg2814z00_977; 
BgL_hnamesz00_2336 = BgL_arg2815z00_978; 
BgL_hnamesz00_970 = BgL_hnamesz00_2336; 
BgL_hooksz00_969 = BgL_hooksz00_2335; 
goto BgL_loopz00_971;} } }  else 
{ /* ./Engine/compiler.scm 158 */
{ /* ./Engine/compiler.scm 158 */
obj_t BgL_arg2821z00_980;
BgL_arg2821z00_980 = 
CAR(BgL_hnamesz00_970); 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string3799z00zzengine_compilerz00, BgL_arg2821z00_980); } } } } } } } 
BGl_checkzd2typeszd2zztype_envz00(); 
BGl_stopzd2onzd2passz00zzengine_passz00(
CNST_TABLE_REF(((long)6)), BGl_hgenzd2walkzd2envz00zzhgen_walkz00); 
BGl_userzd2walkzd2zzuser_userz00(
CELL_REF(BgL_unitsz00_937)); 
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_arg2834z00_982;
BgL_arg2834z00_982 = 
CNST_TABLE_REF(((long)7)); 
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_zc3anonymousza32837ze3z83_2114;
{ 
int BgL_auxz00_2346;int BgL_auxz00_2344;
BgL_auxz00_2346 = 
(int)(((long)1)); 
BgL_auxz00_2344 = 
(int)(((long)0)); 
BgL_zc3anonymousza32837ze3z83_2114 = 
make_fx_procedure(BGl_zc3anonymousza32837ze3z83zzengine_compilerz00, BgL_auxz00_2344, BgL_auxz00_2346); } 
{ /* ./Engine/compiler.scm 168 */
int BgL_auxz00_2349;
BgL_auxz00_2349 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32837ze3z83_2114, BgL_auxz00_2349, BgL_unitsz00_937); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2834z00_982, BgL_zc3anonymousza32837ze3z83_2114); } } 
BGl_installzd2initialzd2expanderz00zzexpand_installz00(); 
BGl_loadzd2libraryzd2initz00zzinit_setrcz00(); 
BGl_expandzd2unitszd2zzexpand_epsz00(
CELL_REF(BgL_unitsz00_937)); 
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_arg2843z00_986;
BgL_arg2843z00_986 = 
CNST_TABLE_REF(((long)8)); 
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_zc3anonymousza32846ze3z83_2113;
{ 
int BgL_auxz00_2359;int BgL_auxz00_2357;
BgL_auxz00_2359 = 
(int)(((long)1)); 
BgL_auxz00_2357 = 
(int)(((long)0)); 
BgL_zc3anonymousza32846ze3z83_2113 = 
make_fx_procedure(BGl_zc3anonymousza32846ze3z83zzengine_compilerz00, BgL_auxz00_2357, BgL_auxz00_2359); } 
{ /* ./Engine/compiler.scm 180 */
int BgL_auxz00_2362;
BgL_auxz00_2362 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32846ze3z83_2113, BgL_auxz00_2362, BgL_unitsz00_937); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2843z00_986, BgL_zc3anonymousza32846ze3z83_2113); } } 
{ /* ./Engine/compiler.scm 183 */
obj_t BgL_astz00_990;
{ /* ./Engine/compiler.scm 183 */
obj_t BgL_cellvalz00_2366;
BgL_cellvalz00_2366 = 
BGl_buildzd2astzd2zzast_buildz00(
CELL_REF(BgL_unitsz00_937)); 
BgL_astz00_990 = 
MAKE_CELL(BgL_cellvalz00_2366); } 
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_arg2849z00_991;
BgL_arg2849z00_991 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_zc3anonymousza32852ze3z83_2112;
{ 
int BgL_auxz00_2371;int BgL_auxz00_2369;
BgL_auxz00_2371 = 
(int)(((long)1)); 
BgL_auxz00_2369 = 
(int)(((long)0)); 
BgL_zc3anonymousza32852ze3z83_2112 = 
make_fx_procedure(BGl_zc3anonymousza32852ze3z83zzengine_compilerz00, BgL_auxz00_2369, BgL_auxz00_2371); } 
{ /* ./Engine/compiler.scm 184 */
int BgL_auxz00_2374;
BgL_auxz00_2374 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32852ze3z83_2112, BgL_auxz00_2374, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2849z00_991, BgL_zc3anonymousza32852ze3z83_2112); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3800z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
if(
CBOOL(BGl_za2warningza2z00zz__errorz00))
{ /* ./Engine/compiler.scm 189 */
BGl_checkzd2globalzd2initializa7ationza7zzast_checkzd2globalzd2initz00(); }  else 
{ /* ./Engine/compiler.scm 189 */BFALSE; } 
{ /* ./Engine/compiler.scm 193 */
obj_t BgL_arg2857z00_995;
BgL_arg2857z00_995 = 
CNST_TABLE_REF(((long)10)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2857z00_995, BGl_proc3801z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 196 */
obj_t BgL_arg2863z00_999;
BgL_arg2863z00_999 = 
CNST_TABLE_REF(((long)11)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2863z00_999, BGl_proc3802z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 199 */
bool_t BgL_test2868z00_1003;
{ /* ./Engine/compiler.scm 199 */
long BgL_n1z00_1575;
BgL_n1z00_1575 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test2868z00_1003 = 
(BgL_n1z00_1575>((long)0)); } 
if(BgL_test2868z00_1003)
{ /* ./Engine/compiler.scm 199 */
BGl_bdbzd2spreadzd2objz12z12zzbdb_spreadzd2objzd2(
CELL_REF(BgL_astz00_990)); }  else 
{ /* ./Engine/compiler.scm 199 */BFALSE; } } 
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_arg2872z00_1004;
BgL_arg2872z00_1004 = 
CNST_TABLE_REF(((long)12)); 
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_zc3anonymousza32875ze3z83_2109;
{ 
int BgL_auxz00_2393;int BgL_auxz00_2391;
BgL_auxz00_2393 = 
(int)(((long)1)); 
BgL_auxz00_2391 = 
(int)(((long)0)); 
BgL_zc3anonymousza32875ze3z83_2109 = 
make_fx_procedure(BGl_zc3anonymousza32875ze3z83zzengine_compilerz00, BgL_auxz00_2391, BgL_auxz00_2393); } 
{ /* ./Engine/compiler.scm 201 */
int BgL_auxz00_2396;
BgL_auxz00_2396 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32875ze3z83_2109, BgL_auxz00_2396, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2872z00_1004, BgL_zc3anonymousza32875ze3z83_2109); } } 
{ /* ./Engine/compiler.scm 205 */
bool_t BgL_test2877z00_1008;
{ /* ./Engine/compiler.scm 205 */
bool_t BgL_test2879z00_1009;
{ /* ./Engine/compiler.scm 205 */
obj_t BgL_objz00_1577;
BgL_objz00_1577 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2879z00_1009 = 
INTEGERP(BgL_objz00_1577); } 
if(BgL_test2879z00_1009)
{ /* ./Engine/compiler.scm 206 */
bool_t BgL_test2880z00_1010;
{ /* ./Engine/compiler.scm 206 */
long BgL_n1z00_1578;
BgL_n1z00_1578 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2880z00_1010 = 
(BgL_n1z00_1578>((long)2)); } 
if(BgL_test2880z00_1010)
{ /* ./Engine/compiler.scm 207 */
bool_t BgL_test2881z00_1011;
{ /* ./Engine/compiler.scm 207 */
obj_t BgL_auxz00_2405;
BgL_auxz00_2405 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test2881z00_1011 = 
CBOOL(BgL_auxz00_2405); } 
if(BgL_test2881z00_1011)
{ /* ./Engine/compiler.scm 207 */
BgL_test2877z00_1008 = ((bool_t)0); }  else 
{ /* ./Engine/compiler.scm 207 */
BgL_test2877z00_1008 = ((bool_t)1); } }  else 
{ /* ./Engine/compiler.scm 206 */
BgL_test2877z00_1008 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 205 */
BgL_test2877z00_1008 = ((bool_t)0); } } 
if(BgL_test2877z00_1008)
{ /* ./Engine/compiler.scm 208 */
obj_t BgL_auxz00_2172;
BgL_auxz00_2172 = 
BGl_tracezd2walkz12zc0zztrace_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2172); }  else 
{ /* ./Engine/compiler.scm 205 */BFALSE; } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3803z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
if(
CBOOL(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
{ /* ./Engine/compiler.scm 214 */
obj_t BgL_auxz00_2173;
BgL_auxz00_2173 = 
BGl_callcczd2walkz12zc0zzcallcc_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2173); }  else 
{ /* ./Engine/compiler.scm 213 */BFALSE; } 
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_arg2888z00_1012;
BgL_arg2888z00_1012 = 
CNST_TABLE_REF(((long)14)); 
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_zc3anonymousza32891ze3z83_2108;
{ 
int BgL_auxz00_2419;int BgL_auxz00_2417;
BgL_auxz00_2419 = 
(int)(((long)1)); 
BgL_auxz00_2417 = 
(int)(((long)0)); 
BgL_zc3anonymousza32891ze3z83_2108 = 
make_fx_procedure(BGl_zc3anonymousza32891ze3z83zzengine_compilerz00, BgL_auxz00_2417, BgL_auxz00_2419); } 
{ /* ./Engine/compiler.scm 215 */
int BgL_auxz00_2422;
BgL_auxz00_2422 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32891ze3z83_2108, BgL_auxz00_2422, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2888z00_1012, BgL_zc3anonymousza32891ze3z83_2108); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3804z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
if(
CBOOL(BGl_za2optimzd2unrollzd2loopzf3za2zf3zzengine_paramz00))
{ /* ./Engine/compiler.scm 219 */
{ /* ./Engine/compiler.scm 221 */
obj_t BgL_auxz00_2174;
BgL_auxz00_2174 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2174); } 
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_arg2896z00_1016;
BgL_arg2896z00_1016 = 
CNST_TABLE_REF(((long)15)); 
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_zc3anonymousza32899ze3z83_2107;
{ 
int BgL_auxz00_2433;int BgL_auxz00_2431;
BgL_auxz00_2433 = 
(int)(((long)1)); 
BgL_auxz00_2431 = 
(int)(((long)0)); 
BgL_zc3anonymousza32899ze3z83_2107 = 
make_fx_procedure(BGl_zc3anonymousza32899ze3z83zzengine_compilerz00, BgL_auxz00_2431, BgL_auxz00_2433); } 
{ /* ./Engine/compiler.scm 222 */
int BgL_auxz00_2436;
BgL_auxz00_2436 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32899ze3z83_2107, BgL_auxz00_2436, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2896z00_1016, BgL_zc3anonymousza32899ze3z83_2107); } } }  else 
{ /* ./Engine/compiler.scm 219 */BFALSE; } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3805z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 226 */
obj_t BgL_auxz00_2175;
BgL_auxz00_2175 = 
BGl_inlinezd2walkz12zc0zzinline_walkz00(
CELL_REF(BgL_astz00_990), 
CNST_TABLE_REF(((long)16))); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2175); } 
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_arg2904z00_1020;
BgL_arg2904z00_1020 = 
CNST_TABLE_REF(((long)17)); 
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_zc3anonymousza32907ze3z83_2106;
{ 
int BgL_auxz00_2446;int BgL_auxz00_2444;
BgL_auxz00_2446 = 
(int)(((long)1)); 
BgL_auxz00_2444 = 
(int)(((long)0)); 
BgL_zc3anonymousza32907ze3z83_2106 = 
make_fx_procedure(BGl_zc3anonymousza32907ze3z83zzengine_compilerz00, BgL_auxz00_2444, BgL_auxz00_2446); } 
{ /* ./Engine/compiler.scm 227 */
int BgL_auxz00_2449;
BgL_auxz00_2449 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32907ze3z83_2106, BgL_auxz00_2449, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2904z00_1020, BgL_zc3anonymousza32907ze3z83_2106); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3806z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 231 */
bool_t BgL_test2910z00_1024;
{ /* ./Engine/compiler.scm 231 */
bool_t BgL_test2912z00_1025;
{ /* ./Engine/compiler.scm 231 */
obj_t BgL_objz00_1580;
BgL_objz00_1580 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2912z00_1025 = 
INTEGERP(BgL_objz00_1580); } 
if(BgL_test2912z00_1025)
{ /* ./Engine/compiler.scm 232 */
bool_t BgL_test2913z00_1026;
{ /* ./Engine/compiler.scm 232 */
long BgL_n1z00_1581;
BgL_n1z00_1581 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2913z00_1026 = 
(BgL_n1z00_1581>((long)0)); } 
if(BgL_test2913z00_1026)
{ /* ./Engine/compiler.scm 233 */
bool_t BgL_test2914z00_1027;
{ /* ./Engine/compiler.scm 233 */
long BgL_n1z00_1583;
BgL_n1z00_1583 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2914z00_1027 = 
(BgL_n1z00_1583<=((long)2)); } 
if(BgL_test2914z00_1027)
{ /* ./Engine/compiler.scm 234 */
bool_t BgL_test2915z00_1028;
{ /* ./Engine/compiler.scm 234 */
obj_t BgL_auxz00_2462;
BgL_auxz00_2462 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test2915z00_1028 = 
CBOOL(BgL_auxz00_2462); } 
if(BgL_test2915z00_1028)
{ /* ./Engine/compiler.scm 234 */
BgL_test2910z00_1024 = ((bool_t)0); }  else 
{ /* ./Engine/compiler.scm 234 */
BgL_test2910z00_1024 = ((bool_t)1); } }  else 
{ /* ./Engine/compiler.scm 233 */
BgL_test2910z00_1024 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 232 */
BgL_test2910z00_1024 = ((bool_t)0); } }  else 
{ /* ./Engine/compiler.scm 231 */
BgL_test2910z00_1024 = ((bool_t)0); } } 
if(BgL_test2910z00_1024)
{ /* ./Engine/compiler.scm 235 */
obj_t BgL_auxz00_2176;
BgL_auxz00_2176 = 
BGl_tracezd2walkz12zc0zztrace_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2176); }  else 
{ /* ./Engine/compiler.scm 231 */BFALSE; } } 
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_arg2921z00_1029;
BgL_arg2921z00_1029 = 
CNST_TABLE_REF(((long)18)); 
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_zc3anonymousza32924ze3z83_2105;
{ 
int BgL_auxz00_2472;int BgL_auxz00_2470;
BgL_auxz00_2472 = 
(int)(((long)1)); 
BgL_auxz00_2470 = 
(int)(((long)0)); 
BgL_zc3anonymousza32924ze3z83_2105 = 
make_fx_procedure(BGl_zc3anonymousza32924ze3z83zzengine_compilerz00, BgL_auxz00_2470, BgL_auxz00_2472); } 
{ /* ./Engine/compiler.scm 236 */
int BgL_auxz00_2475;
BgL_auxz00_2475 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32924ze3z83_2105, BgL_auxz00_2475, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2921z00_1029, BgL_zc3anonymousza32924ze3z83_2105); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3803z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 241 */
bool_t BgL_test2927z00_1033;
{ /* ./Engine/compiler.scm 241 */
bool_t BgL_test2929z00_1034;
{ /* ./Engine/compiler.scm 241 */
obj_t BgL_objz00_1585;
BgL_objz00_1585 = BGl_za2compilerzd2debugza2zd2zzengine_paramz00; 
BgL_test2929z00_1034 = 
INTEGERP(BgL_objz00_1585); } 
if(BgL_test2929z00_1034)
{ /* ./Engine/compiler.scm 241 */
long BgL_n1z00_1586;
BgL_n1z00_1586 = 
(long)CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00); 
BgL_test2927z00_1033 = 
(BgL_n1z00_1586>((long)0)); }  else 
{ /* ./Engine/compiler.scm 241 */
BgL_test2927z00_1033 = ((bool_t)0); } } 
if(BgL_test2927z00_1033)
{ /* ./Engine/compiler.scm 242 */
obj_t BgL_auxz00_2177;
BgL_auxz00_2177 = 
BGl_failzd2walkz12zc0zzfail_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2177); }  else 
{ /* ./Engine/compiler.scm 241 */BFALSE; } } 
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_arg2933z00_1035;
BgL_arg2933z00_1035 = 
CNST_TABLE_REF(((long)19)); 
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_zc3anonymousza32936ze3z83_2104;
{ 
int BgL_auxz00_2489;int BgL_auxz00_2487;
BgL_auxz00_2489 = 
(int)(((long)1)); 
BgL_auxz00_2487 = 
(int)(((long)0)); 
BgL_zc3anonymousza32936ze3z83_2104 = 
make_fx_procedure(BGl_zc3anonymousza32936ze3z83zzengine_compilerz00, BgL_auxz00_2487, BgL_auxz00_2489); } 
{ /* ./Engine/compiler.scm 243 */
int BgL_auxz00_2492;
BgL_auxz00_2492 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32936ze3z83_2104, BgL_auxz00_2492, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2933z00_1035, BgL_zc3anonymousza32936ze3z83_2104); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3807z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 247 */
obj_t BgL_auxz00_2178;
BgL_auxz00_2178 = 
BGl_globaliza7ezd2walkz12z67zzglobaliza7e_walkza7(
CELL_REF(BgL_astz00_990), 
CNST_TABLE_REF(((long)20))); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2178); } 
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_arg2941z00_1039;
BgL_arg2941z00_1039 = 
CNST_TABLE_REF(((long)21)); 
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_zc3anonymousza32944ze3z83_2103;
{ 
int BgL_auxz00_2502;int BgL_auxz00_2500;
BgL_auxz00_2502 = 
(int)(((long)1)); 
BgL_auxz00_2500 = 
(int)(((long)0)); 
BgL_zc3anonymousza32944ze3z83_2103 = 
make_fx_procedure(BGl_zc3anonymousza32944ze3z83zzengine_compilerz00, BgL_auxz00_2500, BgL_auxz00_2502); } 
{ /* ./Engine/compiler.scm 248 */
int BgL_auxz00_2505;
BgL_auxz00_2505 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32944ze3z83_2103, BgL_auxz00_2505, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2941z00_1039, BgL_zc3anonymousza32944ze3z83_2103); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3808z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 252 */
obj_t BgL_auxz00_2179;
BgL_auxz00_2179 = 
BGl_cfazd2walkz12zc0zzcfa_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2179); } 
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_arg2949z00_1043;
BgL_arg2949z00_1043 = 
CNST_TABLE_REF(((long)22)); 
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_zc3anonymousza32952ze3z83_2102;
{ 
int BgL_auxz00_2514;int BgL_auxz00_2512;
BgL_auxz00_2514 = 
(int)(((long)1)); 
BgL_auxz00_2512 = 
(int)(((long)0)); 
BgL_zc3anonymousza32952ze3z83_2102 = 
make_fx_procedure(BGl_zc3anonymousza32952ze3z83zzengine_compilerz00, BgL_auxz00_2512, BgL_auxz00_2514); } 
{ /* ./Engine/compiler.scm 253 */
int BgL_auxz00_2517;
BgL_auxz00_2517 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32952ze3z83_2102, BgL_auxz00_2517, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2949z00_1043, BgL_zc3anonymousza32952ze3z83_2102); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3809z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
BGl_setzd2defaultzd2typez12z12zztype_cachez00(
(BgL_typez00_bglt)(BGl_za2objza2z00zztype_cachez00)); 
{ /* ./Engine/compiler.scm 261 */
obj_t BgL_auxz00_2180;
BgL_auxz00_2180 = 
BGl_integratezd2walkz12zc0zzintegrate_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2180); } 
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_arg2958z00_1047;
BgL_arg2958z00_1047 = 
CNST_TABLE_REF(((long)23)); 
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_zc3anonymousza32961ze3z83_2101;
{ 
int BgL_auxz00_2528;int BgL_auxz00_2526;
BgL_auxz00_2528 = 
(int)(((long)1)); 
BgL_auxz00_2526 = 
(int)(((long)0)); 
BgL_zc3anonymousza32961ze3z83_2101 = 
make_fx_procedure(BGl_zc3anonymousza32961ze3z83zzengine_compilerz00, BgL_auxz00_2526, BgL_auxz00_2528); } 
{ /* ./Engine/compiler.scm 262 */
int BgL_auxz00_2531;
BgL_auxz00_2531 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32961ze3z83_2101, BgL_auxz00_2531, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2958z00_1047, BgL_zc3anonymousza32961ze3z83_2101); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3810z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 266 */
obj_t BgL_auxz00_2181;
BgL_auxz00_2181 = 
BGl_coercezd2walkz12zc0zzcoerce_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2181); } 
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_arg2966z00_1051;
BgL_arg2966z00_1051 = 
CNST_TABLE_REF(((long)24)); 
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_zc3anonymousza32969ze3z83_2100;
{ 
int BgL_auxz00_2540;int BgL_auxz00_2538;
BgL_auxz00_2540 = 
(int)(((long)1)); 
BgL_auxz00_2538 = 
(int)(((long)0)); 
BgL_zc3anonymousza32969ze3z83_2100 = 
make_fx_procedure(BGl_zc3anonymousza32969ze3z83zzengine_compilerz00, BgL_auxz00_2538, BgL_auxz00_2540); } 
{ /* ./Engine/compiler.scm 267 */
int BgL_auxz00_2543;
BgL_auxz00_2543 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32969ze3z83_2100, BgL_auxz00_2543, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2966z00_1051, BgL_zc3anonymousza32969ze3z83_2100); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3811z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 272 */
bool_t BgL_test2972z00_1055;
{ /* ./Engine/compiler.scm 272 */
long BgL_n1z00_1588;
BgL_n1z00_1588 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test2972z00_1055 = 
(BgL_n1z00_1588>=((long)1)); } 
if(BgL_test2972z00_1055)
{ /* ./Engine/compiler.scm 272 */
{ /* ./Engine/compiler.scm 274 */
obj_t BgL_auxz00_2182;
BgL_auxz00_2182 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2182); } 
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_arg2975z00_1056;
BgL_arg2975z00_1056 = 
CNST_TABLE_REF(((long)15)); 
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_zc3anonymousza32978ze3z83_2099;
{ 
int BgL_auxz00_2555;int BgL_auxz00_2553;
BgL_auxz00_2555 = 
(int)(((long)1)); 
BgL_auxz00_2553 = 
(int)(((long)0)); 
BgL_zc3anonymousza32978ze3z83_2099 = 
make_fx_procedure(BGl_zc3anonymousza32978ze3z83zzengine_compilerz00, BgL_auxz00_2553, BgL_auxz00_2555); } 
{ /* ./Engine/compiler.scm 275 */
int BgL_auxz00_2558;
BgL_auxz00_2558 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32978ze3z83_2099, BgL_auxz00_2558, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2975z00_1056, BgL_zc3anonymousza32978ze3z83_2099); } } }  else 
{ /* ./Engine/compiler.scm 272 */BFALSE; } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3805z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 279 */
bool_t BgL_test2982z00_1060;
{ /* ./Engine/compiler.scm 279 */
long BgL_n1z00_1590;
BgL_n1z00_1590 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test2982z00_1060 = 
(BgL_n1z00_1590>=((long)1)); } 
if(BgL_test2982z00_1060)
{ /* ./Engine/compiler.scm 280 */
obj_t BgL_auxz00_2183;
BgL_auxz00_2183 = 
BGl_reducezd2walkz12zc0zzreduce_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2183); }  else 
{ /* ./Engine/compiler.scm 279 */BFALSE; } } 
{ /* ./Engine/compiler.scm 281 */
obj_t BgL_arg2986z00_1061;
BgL_arg2986z00_1061 = 
CNST_TABLE_REF(((long)25)); 
{ /* ./Engine/compiler.scm 281 */
obj_t BgL_zc3anonymousza32989ze3z83_2098;
{ 
int BgL_auxz00_2570;int BgL_auxz00_2568;
BgL_auxz00_2570 = 
(int)(((long)1)); 
BgL_auxz00_2568 = 
(int)(((long)0)); 
BgL_zc3anonymousza32989ze3z83_2098 = 
make_fx_procedure(BGl_zc3anonymousza32989ze3z83zzengine_compilerz00, BgL_auxz00_2568, BgL_auxz00_2570); } 
{ /* ./Engine/compiler.scm 281 */
int BgL_auxz00_2573;
BgL_auxz00_2573 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32989ze3z83_2098, BgL_auxz00_2573, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2986z00_1061, BgL_zc3anonymousza32989ze3z83_2098); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3812z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 285 */
bool_t BgL_test2992z00_1065;
{ /* ./Engine/compiler.scm 285 */
long BgL_n1z00_1592;
BgL_n1z00_1592 = 
(long)CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00); 
BgL_test2992z00_1065 = 
(BgL_n1z00_1592>((long)0)); } 
if(BgL_test2992z00_1065)
{ /* ./Engine/compiler.scm 286 */
obj_t BgL_auxz00_2184;
BgL_auxz00_2184 = 
BGl_bdbzd2walkz12zc0zzbdb_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2184); }  else 
{ /* ./Engine/compiler.scm 285 */BFALSE; } } 
{ /* ./Engine/compiler.scm 287 */
obj_t BgL_arg2996z00_1066;
BgL_arg2996z00_1066 = 
CNST_TABLE_REF(((long)26)); 
{ /* ./Engine/compiler.scm 287 */
obj_t BgL_zc3anonymousza32999ze3z83_2097;
{ 
int BgL_auxz00_2585;int BgL_auxz00_2583;
BgL_auxz00_2585 = 
(int)(((long)1)); 
BgL_auxz00_2583 = 
(int)(((long)0)); 
BgL_zc3anonymousza32999ze3z83_2097 = 
make_fx_procedure(BGl_zc3anonymousza32999ze3z83zzengine_compilerz00, BgL_auxz00_2583, BgL_auxz00_2585); } 
{ /* ./Engine/compiler.scm 287 */
int BgL_auxz00_2588;
BgL_auxz00_2588 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza32999ze3z83_2097, BgL_auxz00_2588, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg2996z00_1066, BgL_zc3anonymousza32999ze3z83_2097); } } 
{ /* ./Engine/compiler.scm 290 */
obj_t BgL_auxz00_2185;
BgL_auxz00_2185 = 
BGl_cnstzd2walkz12zc0zzcnst_walkz00(
CELL_REF(BgL_astz00_990)); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2185); } 
{ /* ./Engine/compiler.scm 291 */
obj_t BgL_arg3003z00_1070;
BgL_arg3003z00_1070 = 
CNST_TABLE_REF(((long)27)); 
{ /* ./Engine/compiler.scm 291 */
obj_t BgL_zc3anonymousza33006ze3z83_2096;
{ 
int BgL_auxz00_2596;int BgL_auxz00_2594;
BgL_auxz00_2596 = 
(int)(((long)1)); 
BgL_auxz00_2594 = 
(int)(((long)0)); 
BgL_zc3anonymousza33006ze3z83_2096 = 
make_fx_procedure(BGl_zc3anonymousza33006ze3z83zzengine_compilerz00, BgL_auxz00_2594, BgL_auxz00_2596); } 
{ /* ./Engine/compiler.scm 291 */
int BgL_auxz00_2599;
BgL_auxz00_2599 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33006ze3z83_2096, BgL_auxz00_2599, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3003z00_1070, BgL_zc3anonymousza33006ze3z83_2096); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3813z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 296 */
bool_t BgL_test3009z00_1074;
{ /* ./Engine/compiler.scm 296 */
long BgL_n1z00_1594;
BgL_n1z00_1594 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test3009z00_1074 = 
(BgL_n1z00_1594>=((long)3)); } 
if(BgL_test3009z00_1074)
{ /* ./Engine/compiler.scm 297 */
obj_t BgL_auxz00_2186;
BgL_auxz00_2186 = 
BGl_inlinezd2walkz12zc0zzinline_walkz00(
CELL_REF(BgL_astz00_990), 
CNST_TABLE_REF(((long)28))); 
CELL_SET(BgL_astz00_990, BgL_auxz00_2186); }  else 
{ /* ./Engine/compiler.scm 296 */BFALSE; } } 
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_arg3013z00_1075;
BgL_arg3013z00_1075 = 
CNST_TABLE_REF(((long)29)); 
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_zc3anonymousza33016ze3z83_2095;
{ 
int BgL_auxz00_2612;int BgL_auxz00_2610;
BgL_auxz00_2612 = 
(int)(((long)1)); 
BgL_auxz00_2610 = 
(int)(((long)0)); 
BgL_zc3anonymousza33016ze3z83_2095 = 
make_fx_procedure(BGl_zc3anonymousza33016ze3z83zzengine_compilerz00, BgL_auxz00_2610, BgL_auxz00_2612); } 
{ /* ./Engine/compiler.scm 298 */
int BgL_auxz00_2615;
BgL_auxz00_2615 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33016ze3z83_2095, BgL_auxz00_2615, BgL_astz00_990); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3013z00_1075, BgL_zc3anonymousza33016ze3z83_2095); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3814z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_990)); 
{ /* ./Engine/compiler.scm 302 */
obj_t BgL_astz00_1079;
{ /* ./Engine/compiler.scm 302 */
obj_t BgL_cellvalz00_2620;
BgL_cellvalz00_2620 = 
BGl_astzb2initializa7ersz15zzcgen_walkz00(
CELL_REF(BgL_astz00_990)); 
BgL_astz00_1079 = 
MAKE_CELL(BgL_cellvalz00_2620); } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3815z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_1079)); 
{ /* ./Engine/compiler.scm 306 */
bool_t BgL_test3020z00_1080;
{ /* ./Engine/compiler.scm 306 */
bool_t BgL_test3029z00_1085;
{ /* ./Engine/compiler.scm 306 */
long BgL_n1z00_1596;
BgL_n1z00_1596 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_test3029z00_1085 = 
(BgL_n1z00_1596>=((long)2)); } 
if(BgL_test3029z00_1085)
{ /* ./Engine/compiler.scm 306 */
BgL_test3020z00_1080 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 307 */
obj_t BgL_auxz00_2626;
BgL_auxz00_2626 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BGl_za2targetzd2languageza2zd2zzengine_paramz00, 
CNST_TABLE_REF(((long)13))); 
BgL_test3020z00_1080 = 
CBOOL(BgL_auxz00_2626); } } 
if(BgL_test3020z00_1080)
{ /* ./Engine/compiler.scm 306 */
{ /* ./Engine/compiler.scm 309 */
obj_t BgL_auxz00_2187;
BgL_auxz00_2187 = 
BGl_effectzd2walkz12zc0zzeffect_walkz00(
CELL_REF(BgL_astz00_1079)); 
CELL_SET(BgL_astz00_1079, BgL_auxz00_2187); } 
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_arg3023z00_1081;
BgL_arg3023z00_1081 = 
CNST_TABLE_REF(((long)30)); 
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_zc3anonymousza33026ze3z83_2094;
{ 
int BgL_auxz00_2635;int BgL_auxz00_2633;
BgL_auxz00_2635 = 
(int)(((long)1)); 
BgL_auxz00_2633 = 
(int)(((long)0)); 
BgL_zc3anonymousza33026ze3z83_2094 = 
make_fx_procedure(BGl_zc3anonymousza33026ze3z83zzengine_compilerz00, BgL_auxz00_2633, BgL_auxz00_2635); } 
{ /* ./Engine/compiler.scm 310 */
int BgL_auxz00_2638;
BgL_auxz00_2638 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33026ze3z83_2094, BgL_auxz00_2638, BgL_astz00_1079); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3023z00_1081, BgL_zc3anonymousza33026ze3z83_2094); } } 
{ /* ./Engine/compiler.scm 311 */
obj_t BgL_auxz00_2188;
BgL_auxz00_2188 = 
BGl_reducezd2walkz12zc0zzreduce_walkz00(
CELL_REF(BgL_astz00_1079)); 
CELL_SET(BgL_astz00_1079, BgL_auxz00_2188); } }  else 
{ /* ./Engine/compiler.scm 306 */BFALSE; } } 
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_arg3033z00_1086;
BgL_arg3033z00_1086 = 
CNST_TABLE_REF(((long)31)); 
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_zc3anonymousza33036ze3z83_2093;
{ 
int BgL_auxz00_2646;int BgL_auxz00_2644;
BgL_auxz00_2646 = 
(int)(((long)1)); 
BgL_auxz00_2644 = 
(int)(((long)0)); 
BgL_zc3anonymousza33036ze3z83_2093 = 
make_fx_procedure(BGl_zc3anonymousza33036ze3z83zzengine_compilerz00, BgL_auxz00_2644, BgL_auxz00_2646); } 
{ /* ./Engine/compiler.scm 312 */
int BgL_auxz00_2649;
BgL_auxz00_2649 = 
(int)(((long)0)); 
PROCEDURE_SET(BgL_zc3anonymousza33036ze3z83_2093, BgL_auxz00_2649, BgL_astz00_1079); } 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3033z00_1086, BgL_zc3anonymousza33036ze3z83_2093); } } 
BGl_checkzd2sharingzd2zzast_checkzd2sharingzd2(BGl_string3816z00zzengine_compilerz00, 
CELL_REF(BgL_astz00_1079)); 
{ /* ./Engine/compiler.scm 315 */
obj_t BgL_casezd2valuezd2_1090;
BgL_casezd2valuezd2_1090 = BGl_za2targetzd2languageza2zd2zzengine_paramz00; 
{ /* ./Engine/compiler.scm 315 */
bool_t BgL_test3039z00_1091;
{ /* ./Engine/compiler.scm 315 */
obj_t BgL_auxz00_2654;
BgL_auxz00_2654 = 
CNST_TABLE_REF(((long)32)); 
BgL_test3039z00_1091 = 
(BgL_casezd2valuezd2_1090==BgL_auxz00_2654); } 
if(BgL_test3039z00_1091)
{ /* ./Engine/compiler.scm 318 */
obj_t BgL_czd2prefixzd2_1092;
BgL_czd2prefixzd2_1092 = 
BGl_cgenzd2walkzd2zzcgen_walkz00(
CELL_REF(BgL_astz00_1079)); 
{ /* ./Engine/compiler.scm 319 */
obj_t BgL_arg3041z00_1093;
BgL_arg3041z00_1093 = 
CNST_TABLE_REF(((long)33)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3041z00_1093, BGl_proc3817z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 320 */
obj_t BgL_arg3046z00_1097;
BgL_arg3046z00_1097 = 
CNST_TABLE_REF(((long)34)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3046z00_1097, BGl_proc3818z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 321 */
bool_t BgL_test3050z00_1101;
BgL_test3050z00_1101 = 
STRINGP(BgL_czd2prefixzd2_1092); 
if(BgL_test3050z00_1101)
{ /* ./Engine/compiler.scm 321 */
{ /* ./Engine/compiler.scm 323 */
bool_t BgL_test3051z00_1102;
{ /* ./Engine/compiler.scm 323 */
bool_t BgL_test3053z00_1103;
{ /* ./Engine/compiler.scm 323 */
obj_t BgL_auxz00_2665;
BgL_auxz00_2665 = 
CNST_TABLE_REF(((long)35)); 
BgL_test3053z00_1103 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_2665); } 
if(BgL_test3053z00_1103)
{ /* ./Engine/compiler.scm 323 */
BgL_test3051z00_1102 = ((bool_t)1); }  else 
{ /* ./Engine/compiler.scm 323 */
BgL_test3051z00_1102 = 
CBOOL(BGl_za2czd2debugza2zd2zzengine_paramz00); } } 
if(BgL_test3051z00_1102)
{ /* ./Engine/compiler.scm 323 */
BGl_indentz00zzcc_indentz00(BgL_czd2prefixzd2_1092); }  else 
{ /* ./Engine/compiler.scm 323 */BFALSE; } } 
{ /* ./Engine/compiler.scm 325 */
obj_t BgL_arg3056z00_1104;
BgL_arg3056z00_1104 = 
CNST_TABLE_REF(((long)35)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3056z00_1104, BGl_proc3819z00zzengine_compilerz00); } 
BGl_cczd2compilerzd2zzengine_compilerz00(BgL_czd2prefixzd2_1092, BFALSE); }  else 
{ /* ./Engine/compiler.scm 321 */BFALSE; } } }  else 
{ /* ./Engine/compiler.scm 315 */
bool_t BgL_test3063z00_1108;
{ /* ./Engine/compiler.scm 315 */
obj_t BgL_auxz00_2675;
BgL_auxz00_2675 = 
CNST_TABLE_REF(((long)36)); 
BgL_test3063z00_1108 = 
(BgL_casezd2valuezd2_1090==BgL_auxz00_2675); } 
if(BgL_test3063z00_1108)
{ /* ./Engine/compiler.scm 315 */
BGl_jvmzd2dumpzd2zzjvm_jdumpz00(
CELL_REF(BgL_astz00_1079)); 
{ /* ./Engine/compiler.scm 330 */
obj_t BgL_arg3066z00_1109;
BgL_arg3066z00_1109 = 
CNST_TABLE_REF(((long)37)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3066z00_1109, BGl_proc3820z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 331 */
obj_t BgL_arg3071z00_1113;
BgL_arg3071z00_1113 = 
CNST_TABLE_REF(((long)38)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3071z00_1113, BGl_proc3821z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 332 */
obj_t BgL_arg3076z00_1117;
BgL_arg3076z00_1117 = 
CNST_TABLE_REF(((long)39)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3076z00_1117, BGl_proc3822z00zzengine_compilerz00); } 
BGl_jvmzd2ldzd2zzjvm_ldz00(); }  else 
{ /* ./Engine/compiler.scm 315 */
bool_t BgL_test3081z00_1121;
{ /* ./Engine/compiler.scm 315 */
obj_t BgL_auxz00_2687;
BgL_auxz00_2687 = 
CNST_TABLE_REF(((long)40)); 
BgL_test3081z00_1121 = 
(BgL_casezd2valuezd2_1090==BgL_auxz00_2687); } 
if(BgL_test3081z00_1121)
{ /* ./Engine/compiler.scm 315 */
BGl_dotnetz00zzdotnet_dotnetz00(
CELL_REF(BgL_astz00_1079)); 
{ /* ./Engine/compiler.scm 337 */
obj_t BgL_arg3084z00_1122;
BgL_arg3084z00_1122 = 
CNST_TABLE_REF(((long)41)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3084z00_1122, BGl_proc3823z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 338 */
obj_t BgL_arg3089z00_1126;
BgL_arg3089z00_1126 = 
CNST_TABLE_REF(((long)37)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3089z00_1126, BGl_proc3824z00zzengine_compilerz00); } 
BGl_dotnetzd2ldzd2zzdotnet_ldz00(); }  else 
{ /* ./Engine/compiler.scm 341 */
obj_t BgL_objectz00_1601;
BgL_objectz00_1601 = BGl_za2targetzd2languageza2zd2zzengine_paramz00; 
FAILURE(BGl_string3825z00zzengine_compilerz00,BGl_string3826z00zzengine_compilerz00,BgL_objectz00_1601);} } } } } } 
return 
BINT(((long)0));} } } } } } } 
}



/* _compiler */
obj_t BGl__compilerz00zzengine_compilerz00(obj_t BgL_envz00_2117)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 78 */
return 
BGl_compilerz00zzengine_compilerz00();} 
}



/* <anonymous:3059> */
obj_t BGl_zc3anonymousza33059ze3z83zzengine_compilerz00(obj_t BgL_envz00_2118)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 325 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3049> */
obj_t BGl_zc3anonymousza33049ze3z83zzengine_compilerz00(obj_t BgL_envz00_2119)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 320 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3044> */
obj_t BGl_zc3anonymousza33044ze3z83zzengine_compilerz00(obj_t BgL_envz00_2120)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 319 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3079> */
obj_t BGl_zc3anonymousza33079ze3z83zzengine_compilerz00(obj_t BgL_envz00_2121)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 332 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3074> */
obj_t BGl_zc3anonymousza33074ze3z83zzengine_compilerz00(obj_t BgL_envz00_2122)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 331 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3069> */
obj_t BGl_zc3anonymousza33069ze3z83zzengine_compilerz00(obj_t BgL_envz00_2123)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 330 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3092> */
obj_t BGl_zc3anonymousza33092ze3z83zzengine_compilerz00(obj_t BgL_envz00_2124)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 338 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3087> */
obj_t BGl_zc3anonymousza33087ze3z83zzengine_compilerz00(obj_t BgL_envz00_2125)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 337 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* <anonymous:3036> */
obj_t BGl_zc3anonymousza33036ze3z83zzengine_compilerz00(obj_t BgL_envz00_2126)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 312 */
{ /* ./Engine/compiler.scm 312 */
obj_t BgL_astz00_2127;
{ /* ./Engine/compiler.scm 312 */
int BgL_auxz00_2708;
BgL_auxz00_2708 = 
(int)(((long)0)); 
BgL_astz00_2127 = 
PROCEDURE_REF(BgL_envz00_2126, BgL_auxz00_2708); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2127));} } } 
}



/* <anonymous:3026> */
obj_t BGl_zc3anonymousza33026ze3z83zzengine_compilerz00(obj_t BgL_envz00_2128)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 310 */
{ /* ./Engine/compiler.scm 310 */
obj_t BgL_astz00_2129;
{ /* ./Engine/compiler.scm 310 */
int BgL_auxz00_2712;
BgL_auxz00_2712 = 
(int)(((long)0)); 
BgL_astz00_2129 = 
PROCEDURE_REF(BgL_envz00_2128, BgL_auxz00_2712); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2129));} } } 
}



/* <anonymous:3016> */
obj_t BGl_zc3anonymousza33016ze3z83zzengine_compilerz00(obj_t BgL_envz00_2130)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 298 */
{ /* ./Engine/compiler.scm 298 */
obj_t BgL_astz00_2131;
{ /* ./Engine/compiler.scm 298 */
int BgL_auxz00_2716;
BgL_auxz00_2716 = 
(int)(((long)0)); 
BgL_astz00_2131 = 
PROCEDURE_REF(BgL_envz00_2130, BgL_auxz00_2716); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2131));} } } 
}



/* <anonymous:3006> */
obj_t BGl_zc3anonymousza33006ze3z83zzengine_compilerz00(obj_t BgL_envz00_2132)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 291 */
{ /* ./Engine/compiler.scm 291 */
obj_t BgL_astz00_2133;
{ /* ./Engine/compiler.scm 291 */
int BgL_auxz00_2720;
BgL_auxz00_2720 = 
(int)(((long)0)); 
BgL_astz00_2133 = 
PROCEDURE_REF(BgL_envz00_2132, BgL_auxz00_2720); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2133));} } } 
}



/* <anonymous:2999> */
obj_t BGl_zc3anonymousza32999ze3z83zzengine_compilerz00(obj_t BgL_envz00_2134)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 287 */
{ /* ./Engine/compiler.scm 287 */
obj_t BgL_astz00_2135;
{ /* ./Engine/compiler.scm 287 */
int BgL_auxz00_2724;
BgL_auxz00_2724 = 
(int)(((long)0)); 
BgL_astz00_2135 = 
PROCEDURE_REF(BgL_envz00_2134, BgL_auxz00_2724); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2135));} } } 
}



/* <anonymous:2989> */
obj_t BGl_zc3anonymousza32989ze3z83zzengine_compilerz00(obj_t BgL_envz00_2136)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 281 */
{ /* ./Engine/compiler.scm 281 */
obj_t BgL_astz00_2137;
{ /* ./Engine/compiler.scm 281 */
int BgL_auxz00_2728;
BgL_auxz00_2728 = 
(int)(((long)0)); 
BgL_astz00_2137 = 
PROCEDURE_REF(BgL_envz00_2136, BgL_auxz00_2728); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2137));} } } 
}



/* <anonymous:2978> */
obj_t BGl_zc3anonymousza32978ze3z83zzengine_compilerz00(obj_t BgL_envz00_2138)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 275 */
{ /* ./Engine/compiler.scm 275 */
obj_t BgL_astz00_2139;
{ /* ./Engine/compiler.scm 275 */
int BgL_auxz00_2732;
BgL_auxz00_2732 = 
(int)(((long)0)); 
BgL_astz00_2139 = 
PROCEDURE_REF(BgL_envz00_2138, BgL_auxz00_2732); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2139));} } } 
}



/* <anonymous:2969> */
obj_t BGl_zc3anonymousza32969ze3z83zzengine_compilerz00(obj_t BgL_envz00_2140)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 267 */
{ /* ./Engine/compiler.scm 267 */
obj_t BgL_astz00_2141;
{ /* ./Engine/compiler.scm 267 */
int BgL_auxz00_2736;
BgL_auxz00_2736 = 
(int)(((long)0)); 
BgL_astz00_2141 = 
PROCEDURE_REF(BgL_envz00_2140, BgL_auxz00_2736); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2141));} } } 
}



/* <anonymous:2961> */
obj_t BGl_zc3anonymousza32961ze3z83zzengine_compilerz00(obj_t BgL_envz00_2142)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 262 */
{ /* ./Engine/compiler.scm 262 */
obj_t BgL_astz00_2143;
{ /* ./Engine/compiler.scm 262 */
int BgL_auxz00_2740;
BgL_auxz00_2740 = 
(int)(((long)0)); 
BgL_astz00_2143 = 
PROCEDURE_REF(BgL_envz00_2142, BgL_auxz00_2740); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2143));} } } 
}



/* <anonymous:2952> */
obj_t BGl_zc3anonymousza32952ze3z83zzengine_compilerz00(obj_t BgL_envz00_2144)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 253 */
{ /* ./Engine/compiler.scm 253 */
obj_t BgL_astz00_2145;
{ /* ./Engine/compiler.scm 253 */
int BgL_auxz00_2744;
BgL_auxz00_2744 = 
(int)(((long)0)); 
BgL_astz00_2145 = 
PROCEDURE_REF(BgL_envz00_2144, BgL_auxz00_2744); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2145));} } } 
}



/* <anonymous:2944> */
obj_t BGl_zc3anonymousza32944ze3z83zzengine_compilerz00(obj_t BgL_envz00_2146)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 248 */
{ /* ./Engine/compiler.scm 248 */
obj_t BgL_astz00_2147;
{ /* ./Engine/compiler.scm 248 */
int BgL_auxz00_2748;
BgL_auxz00_2748 = 
(int)(((long)0)); 
BgL_astz00_2147 = 
PROCEDURE_REF(BgL_envz00_2146, BgL_auxz00_2748); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2147));} } } 
}



/* <anonymous:2936> */
obj_t BGl_zc3anonymousza32936ze3z83zzengine_compilerz00(obj_t BgL_envz00_2148)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 243 */
{ /* ./Engine/compiler.scm 243 */
obj_t BgL_astz00_2149;
{ /* ./Engine/compiler.scm 243 */
int BgL_auxz00_2752;
BgL_auxz00_2752 = 
(int)(((long)0)); 
BgL_astz00_2149 = 
PROCEDURE_REF(BgL_envz00_2148, BgL_auxz00_2752); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2149));} } } 
}



/* <anonymous:2924> */
obj_t BGl_zc3anonymousza32924ze3z83zzengine_compilerz00(obj_t BgL_envz00_2150)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 236 */
{ /* ./Engine/compiler.scm 236 */
obj_t BgL_astz00_2151;
{ /* ./Engine/compiler.scm 236 */
int BgL_auxz00_2756;
BgL_auxz00_2756 = 
(int)(((long)0)); 
BgL_astz00_2151 = 
PROCEDURE_REF(BgL_envz00_2150, BgL_auxz00_2756); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2151));} } } 
}



/* <anonymous:2907> */
obj_t BGl_zc3anonymousza32907ze3z83zzengine_compilerz00(obj_t BgL_envz00_2152)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 227 */
{ /* ./Engine/compiler.scm 227 */
obj_t BgL_astz00_2153;
{ /* ./Engine/compiler.scm 227 */
int BgL_auxz00_2760;
BgL_auxz00_2760 = 
(int)(((long)0)); 
BgL_astz00_2153 = 
PROCEDURE_REF(BgL_envz00_2152, BgL_auxz00_2760); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2153));} } } 
}



/* <anonymous:2899> */
obj_t BGl_zc3anonymousza32899ze3z83zzengine_compilerz00(obj_t BgL_envz00_2154)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 222 */
{ /* ./Engine/compiler.scm 222 */
obj_t BgL_astz00_2155;
{ /* ./Engine/compiler.scm 222 */
int BgL_auxz00_2764;
BgL_auxz00_2764 = 
(int)(((long)0)); 
BgL_astz00_2155 = 
PROCEDURE_REF(BgL_envz00_2154, BgL_auxz00_2764); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2155));} } } 
}



/* <anonymous:2891> */
obj_t BGl_zc3anonymousza32891ze3z83zzengine_compilerz00(obj_t BgL_envz00_2156)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 215 */
{ /* ./Engine/compiler.scm 215 */
obj_t BgL_astz00_2157;
{ /* ./Engine/compiler.scm 215 */
int BgL_auxz00_2768;
BgL_auxz00_2768 = 
(int)(((long)0)); 
BgL_astz00_2157 = 
PROCEDURE_REF(BgL_envz00_2156, BgL_auxz00_2768); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2157));} } } 
}



/* <anonymous:2875> */
obj_t BGl_zc3anonymousza32875ze3z83zzengine_compilerz00(obj_t BgL_envz00_2158)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 201 */
{ /* ./Engine/compiler.scm 201 */
obj_t BgL_astz00_2159;
{ /* ./Engine/compiler.scm 201 */
int BgL_auxz00_2772;
BgL_auxz00_2772 = 
(int)(((long)0)); 
BgL_astz00_2159 = 
PROCEDURE_REF(BgL_envz00_2158, BgL_auxz00_2772); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2159));} } } 
}



/* <anonymous:2866> */
obj_t BGl_zc3anonymousza32866ze3z83zzengine_compilerz00(obj_t BgL_envz00_2160)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 196 */
{ 

return 
BGl_makezd2addzd2heapz00zzheap_makez00();} } 
}



/* <anonymous:2860> */
obj_t BGl_zc3anonymousza32860ze3z83zzengine_compilerz00(obj_t BgL_envz00_2161)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 193 */
{ 

return 
BGl_makezd2heapzd2zzheap_makez00();} } 
}



/* <anonymous:2852> */
obj_t BGl_zc3anonymousza32852ze3z83zzengine_compilerz00(obj_t BgL_envz00_2162)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 184 */
{ /* ./Engine/compiler.scm 184 */
obj_t BgL_astz00_2163;
{ /* ./Engine/compiler.scm 184 */
int BgL_auxz00_2778;
BgL_auxz00_2778 = 
(int)(((long)0)); 
BgL_astz00_2163 = 
PROCEDURE_REF(BgL_envz00_2162, BgL_auxz00_2778); } 
{ 

return 
BGl_writezd2astzd2zzwrite_astz00(
CELL_REF(BgL_astz00_2163));} } } 
}



/* <anonymous:2846> */
obj_t BGl_zc3anonymousza32846ze3z83zzengine_compilerz00(obj_t BgL_envz00_2164)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 180 */
{ /* ./Engine/compiler.scm 180 */
obj_t BgL_unitsz00_2165;
{ /* ./Engine/compiler.scm 180 */
int BgL_auxz00_2782;
BgL_auxz00_2782 = 
(int)(((long)0)); 
BgL_unitsz00_2165 = 
PROCEDURE_REF(BgL_envz00_2164, BgL_auxz00_2782); } 
{ 

return 
BGl_writezd2expandedzd2zzwrite_expandedz00(
CELL_REF(BgL_unitsz00_2165));} } } 
}



/* <anonymous:2837> */
obj_t BGl_zc3anonymousza32837ze3z83zzengine_compilerz00(obj_t BgL_envz00_2166)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 168 */
{ /* ./Engine/compiler.scm 168 */
obj_t BgL_unitsz00_2167;
{ /* ./Engine/compiler.scm 168 */
int BgL_auxz00_2786;
BgL_auxz00_2786 = 
(int)(((long)0)); 
BgL_unitsz00_2167 = 
PROCEDURE_REF(BgL_envz00_2166, BgL_auxz00_2786); } 
{ 

return 
BGl_writezd2expandedzd2zzwrite_expandedz00(
CELL_REF(BgL_unitsz00_2167));} } } 
}



/* <anonymous:2761> */
obj_t BGl_zc3anonymousza32761ze3z83zzengine_compilerz00(obj_t BgL_envz00_2168)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 140 */
{ 

{ /* ./Engine/compiler.scm 140 */
long BgL_auxz00_2790;
BgL_auxz00_2790 = ((long)0); 
return 
BINT(BgL_auxz00_2790);} } } 
}



/* <anonymous:2748> */
obj_t BGl_zc3anonymousza32748ze3z83zzengine_compilerz00(obj_t BgL_envz00_2169)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 131 */
{ 

return 
BGl_dumpzd2additionalzd2heapsz00zzheap_restorez00();} } 
}



/* cc-compiler */
BGL_EXPORTED_DEF obj_t BGl_cczd2compilerzd2zzengine_compilerz00(obj_t BgL_czd2prefixzd2_19, obj_t BgL_ozd2prefixzd2_20)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 350 */
{ /* ./Engine/compiler.scm 352 */
bool_t BgL_arg3105z00_1130;
{ /* ./Engine/compiler.scm 352 */
bool_t BgL_test3107z00_1131;
{ /* ./Engine/compiler.scm 352 */
obj_t BgL_auxz00_2793;
BgL_auxz00_2793 = 
CNST_TABLE_REF(((long)37)); 
BgL_test3107z00_1131 = 
(BGl_za2passza2z00zzengine_paramz00==BgL_auxz00_2793); } 
if(BgL_test3107z00_1131)
{ /* ./Engine/compiler.scm 352 */
BgL_arg3105z00_1130 = ((bool_t)0); }  else 
{ /* ./Engine/compiler.scm 352 */
BgL_arg3105z00_1130 = ((bool_t)1); } } 
BGl_ccz00zzcc_ccz00(BgL_czd2prefixzd2_19, BgL_ozd2prefixzd2_20, BgL_arg3105z00_1130); } 
{ /* ./Engine/compiler.scm 353 */
obj_t BgL_arg3110z00_1132;
BgL_arg3110z00_1132 = 
CNST_TABLE_REF(((long)37)); 
BGl_stopzd2onzd2passz00zzengine_passz00(BgL_arg3110z00_1132, BGl_proc3827z00zzengine_compilerz00); } 
{ /* ./Engine/compiler.scm 355 */
obj_t BgL_arg3115z00_1136;
if(
STRINGP(BgL_ozd2prefixzd2_20))
{ /* ./Engine/compiler.scm 355 */
BgL_arg3115z00_1136 = BgL_ozd2prefixzd2_20; }  else 
{ /* ./Engine/compiler.scm 355 */
BgL_arg3115z00_1136 = BgL_czd2prefixzd2_19; } 
return 
BGl_ldz00zzcc_ldz00(BgL_arg3115z00_1136, ((bool_t)0));} } 
}



/* _cc-compiler */
obj_t BGl__cczd2compilerzd2zzengine_compilerz00(obj_t BgL_envz00_2190, obj_t BgL_czd2prefixzd2_2191, obj_t BgL_ozd2prefixzd2_2192)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 350 */
return 
BGl_cczd2compilerzd2zzengine_compilerz00(BgL_czd2prefixzd2_2191, BgL_ozd2prefixzd2_2192);} 
}



/* <anonymous:3113> */
obj_t BGl_zc3anonymousza33113ze3z83zzengine_compilerz00(obj_t BgL_envz00_2193)
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 353 */
{ 

return 
CNST_TABLE_REF(((long)42));} } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzengine_compilerz00()
{ AN_OBJECT;
{ /* ./Engine/compiler.scm 15 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23537), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)25566), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)10268), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_signalsz00(((long)49314), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)8510), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzengine_enginez00(((long)46992), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_srcz00(((long)46676), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzwrite_expandedz00(((long)47979), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzwrite_astz00(((long)3027), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_accessz00(((long)2266), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzread_jvmz00(((long)16338), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzheap_restorez00(((long)18765), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzheap_makez00(((long)38589), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)62031), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_checkzd2sharingzd2(((long)39711), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28323), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_buildz00(((long)17453), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_unitz00(((long)47192), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzast_checkzd2globalzd2initz00(((long)43075), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzuser_userz00(((long)28513), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_envz00(((long)25186), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztype_cachez00(((long)30651), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long)8699), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzmodule_includez00(((long)1783), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzexpand_epsz00(((long)17978), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzexpand_installz00(((long)63390), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinit_mainz00(((long)6610), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinit_setrcz00(((long)1658), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zztrace_walkz00(((long)47784), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzinline_walkz00(((long)17469), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzeffect_walkz00(((long)63802), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcallcc_walkz00(((long)61694), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzfail_walkz00(((long)6090), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzglobaliza7e_walkza7(((long)59349), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcfa_walkz00(((long)30794), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long)20474), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzintegrate_walkz00(((long)15305), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcoerce_walkz00(((long)1305), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzreduce_walkz00(((long)36075), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcnst_walkz00(((long)13595), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcgen_walkz00(((long)5293), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzhgen_walkz00(((long)30920), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_settingz00(((long)20468), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_spreadzd2objzd2(((long)59242), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzbdb_walkz00(((long)59963), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzprof_walkz00(((long)40796), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_indentz00(((long)1912), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_ccz00(((long)15172), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzcc_ldz00(((long)36014), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzjvm_jdumpz00(((long)43692), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzjvm_ldz00(((long)12620), "engine_compiler"); 
BGl_modulezd2initializa7ationz75zzdotnet_dotnetz00(((long)3361), "engine_compiler"); 
return 
BGl_modulezd2initializa7ationz75zzdotnet_ldz00(((long)13132), "engine_compiler");} 
}

