;*=====================================================================*/
;*    serrano/prgm/project/bigloo/fthread/src/Llib/_thread.scm         */
;*    -------------------------------------------------------------    */
;*    Author      :  Frederic Boussinot                                */
;*    Creation    :  Mon Jan  7 13:50:54 2002                          */
;*    Last change :  Fri Jun 13 05:22:45 2003 (serrano)                */
;*    Copyright   :  2002-03 F. Boussinot                              */
;*    -------------------------------------------------------------    */
;*    Fair threads                                                     */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __ft_%thread
   
   (import __ft_types
	   __ft_%types
	   __ft_signal)
   
   (java   (class %jobject "java.lang.Object")
	   
	   (class %bgl-asynchronous-thunk
	      (constructor new (::procedure ::obj ::obj ::obj))
	      (method start::void (::%bgl-asynchronous-thunk)
		      "start")
	      (method static scheduler-funcall::obj (::procedure ::obj)
		      "funcall")
	      (method static scheduler-funcall2::obj (::procedure ::obj ::obj)
		      "funcall2")
	      (method static await!::void (::obj)
		      "await")
	      (method static print::obj (::bstring ::output-port)
		      "print")
	      "bigloo.fairthread.BglAsyncThunk")
	   
	   (class %bgl-thread
	      (constructor new (::procedure))
	      (constructor new/name (::procedure ::symbol))
	      (method start::void (::%bgl-thread) "start")
	      (method setup!::void (::%bgl-thread ::obj) "setup")
	      (method detach-id-set!::void (::%bgl-thread ::obj) "detachIdSet")
	      (method obj::obj (::%bgl-thread) "getBglObj")
	      (method switch::void (::%bgl-thread ::%bgl-thread) "switchExit")
	      (method wait-for-token::void (::%bgl-thread) "waitForToken")
	      (method switch-to::void (::%bgl-thread ::%bgl-thread) "switchTo")
	      (method static switch-in::void (::%bgl-thread) "switchIn")
	      (method switch-out::void (::%bgl-thread) "switchOut")
	      "bigloo.fairthread.BglThread"))

   (extern (include "bglthread.h")
	   (type %bgl-thread (opaque) "bglthread_t")
	   (macro %bgl-thread-start::void (::%bgl-thread)
		  "bglthread_start")
	   (macro %bgl-thread-new::%bgl-thread (::procedure)
		  "bglthread_new")
	   (macro %bgl-thread-new/name::%bgl-thread (::procedure ::symbol)
		  "bglthread_new_with_name")
	   (macro %bgl-thread-detach-id-set!::obj (::%bgl-thread ::obj)
		  "bglthread_id_set")
	   (macro %bgl-thread-setup!::void (::%bgl-thread ::obj)
		  "bglthread_setup")
	   (macro %bgl-thread-switch::void (::%bgl-thread ::%bgl-thread)
		  "bglthread_switch")
	   (macro %bgl-thread-wait-for-token::void (::%bgl-thread)
		  "bglthread_wait_for_token")
	   (macro %bgl-thread-switch-to::void (::%bgl-thread ::%bgl-thread)
		  "bglthread_switch_to")
	   (macro %bgl-thread-switch-in::void (::%bgl-thread)
		  "bglthread_switch_in")
	   (macro %bgl-thread-switch-out::void (::%bgl-thread)
		  "bglthread_switch_out")
	   (macro %bgl-asynchronous-thunk-scheduler-funcall::obj (::procedure ::obj)
		  "bglthread_async_scheduler_funcall")
	   (macro %bgl-asynchronous-thunk-scheduler-funcall2::obj (::procedure ::obj ::obj)
		  "bglthread_async_scheduler_funcall2")
	   (macro %bgl-asynchronous-thunk-new::%bgl-thread (::procedure ::obj ::obj ::obj)
		  "bglthread_async_new")
	   (macro %bgl-asynchronous-thunk-start::void (::%bgl-thread)
		  "bglthread_async_start")
	   (macro %bgl-asynchronous-thunk-await!::void (::obj)
		  "bglthread_async_await")
	   (macro %bgl-asynchronous-thunk-print::obj (::bstring ::output-port)
		  "bglthread_async_print"))
   
   (export (thread-setup! ::thread)
	   
	   (thread-switch-then-exit ::thread)
	   (thread-switch-to ::thread ::thread)
	   (thread-switch-in ::thread)
	   (thread-switch-out ::thread)
	   
	   (thread-attached? ::thread)
	   (thread-dead? ::thread)
	   (thread-cooperate ::thread)
	   (thread-%detach! ::thread ::symbol)
	   (thread-%attach! ::thread)
	   
	   (thread-set-runnable! ::thread)
	   (thread-set-eoi! ::thread ::int)
	   (thread-unset-eoi! ::thread)
	   (thread-set-await! ::thread)
	   (thread-set-yield! ::thread ::int)
	   (thread-set-dead! ::thread)

	   (thread-add-mutex! ::thread ::mutex)
	   (thread-del-mutex! ::thread ::mutex)))

;*---------------------------------------------------------------------*/
;*    *thread-counter* ...                                             */
;*---------------------------------------------------------------------*/
(define *thread-counter* 0)

;*---------------------------------------------------------------------*/
;*    thread-setup! ...                                                */
;*---------------------------------------------------------------------*/
(define (thread-setup! thread)
   (set! *thread-counter* (+fx 1 *thread-counter*))
   (with-access::thread thread (%builtin %ident)
      (%bgl-thread-setup! %builtin thread)
      (set! %ident *thread-counter*)
      thread))

;*---------------------------------------------------------------------*/
;*    next-thread ...                                                  */
;*---------------------------------------------------------------------*/
(define (next-thread from)
   (with-access::thread from (scheduler)
      (with-access::%scheduler scheduler (torun)
	 (if (pair? torun)
	     (let ((nt (car torun)))
		(set! torun (cdr torun))
		(%scheduler-current-thread-set! scheduler nt)
		nt)
	     scheduler))))

;*---------------------------------------------------------------------*/
;*    thread-switch-then-exit ...                                      */
;*---------------------------------------------------------------------*/
(define (thread-switch-then-exit from)
   (let ((to (next-thread from)))
      (%bgl-thread-switch (thread-%builtin from) (thread-%builtin to))
      to))

;*---------------------------------------------------------------------*/
;*    thread-switch-to ...                                             */
;*---------------------------------------------------------------------*/
(define (thread-switch-to from to)
   (%bgl-thread-switch-to (thread-%builtin from) (thread-%builtin to))
   to)

;*---------------------------------------------------------------------*/
;*    thread-switch-in ...                                             */
;*---------------------------------------------------------------------*/
(define (thread-switch-in to)
   (%bgl-thread-switch-in (thread-%builtin to))
   to)

;*---------------------------------------------------------------------*/
;*    thread-switch-out ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-switch-out from)
   (%bgl-thread-switch-out (thread-%builtin from))
   from)

;*---------------------------------------------------------------------*/
;*    thread-attached? ...                                             */
;*---------------------------------------------------------------------*/
(define (thread-attached? t)
   (thread-scheduler t))

;*---------------------------------------------------------------------*/
;*    thread-dead? ...                                                 */
;*---------------------------------------------------------------------*/
(define (thread-dead? t)
   (with-access::thread t (scheduler %state)
      (eq? %state 'dead)))

;*---------------------------------------------------------------------*/
;*    thread-cooperate ...                                             */
;*---------------------------------------------------------------------*/
(define (thread-cooperate t)
   (thread-switch-to t (next-thread t))
   (with-access::thread t (%state scheduler %terminate)
      (if (eq? %state 'dying)
	  (%terminate t))))

;*---------------------------------------------------------------------*/
;*    thread-%detach! ...                                              */
;*---------------------------------------------------------------------*/
(define (thread-%detach! t id)
   (with-access::thread t (scheduler)
      (%bgl-thread-detach-id-set! (thread-%builtin t) id)
      (%bgl-thread-switch (thread-%builtin t)
			  (thread-%builtin (next-thread t))))
   #unspecified)

;*---------------------------------------------------------------------*/
;*    thread-%attach! ...                                              */
;*---------------------------------------------------------------------*/
(define (thread-%attach! t)
   (with-access::thread t (%state %terminate name)
      (%bgl-thread-detach-id-set! (thread-%builtin t) name)
      (%bgl-thread-wait-for-token (thread-%builtin t))
      (if (eq? %state 'dying)
	  (%terminate t))))

;*---------------------------------------------------------------------*/
;*    thread-set-runnable! ...                                         */
;*---------------------------------------------------------------------*/
(define (thread-set-runnable! t)
   (with-access::thread t (scheduler %state %timeout)
      (set! %timeout 0)
      ;; we have to take care to avoid resurection
      (if (not (memq %state '(dying dead runnable)))
	  (begin
	     (set! %state 'runnable)
	     (with-access::%scheduler scheduler (threads-runnable)
		(set! threads-runnable (cons t threads-runnable)))))))

;*---------------------------------------------------------------------*/
;*    thread-set-eoi! ...                                              */
;*---------------------------------------------------------------------*/
(define (thread-set-eoi! t tmt)
   (with-access::thread t (scheduler %state %timeout)
      (set! %timeout tmt)
      (with-access::%scheduler scheduler (threads-eoi)
	 (set! threads-eoi (cons t threads-eoi)))))

;*---------------------------------------------------------------------*/
;*    thread-unset-eoi! ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-unset-eoi! t)
   (with-access::thread t (scheduler %state)
      (set! %state 'runnable)
      (with-access::%scheduler scheduler (threads-eoi)
	 (set! threads-eoi (remq! t threads-eoi)))))

;*---------------------------------------------------------------------*/
;*    thread-set-await! ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-set-await! t)
   (with-access::thread t (%state)
      (set! %state 'await)))

;*---------------------------------------------------------------------*/
;*    thread-set-yield! ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-set-yield! t tmt)
   (with-access::thread t (scheduler %state %timeout)
      (set! %state 'yield)
      (set! %timeout tmt)
      (with-access::%scheduler scheduler (threads-yield)
	 (set! threads-yield (cons t threads-yield)))))

;*---------------------------------------------------------------------*/
;*    thread-set-dead! ...                                             */
;*---------------------------------------------------------------------*/
(define (thread-set-dead! t)
   (with-access::thread t (scheduler %state %timeout)
      (set! %state 'dead)
      (set! %timeout 0)
      (with-access::%scheduler scheduler (threads-runnable threads-eoi deadn)
	 (set! deadn (+fx 1 deadn))
	 (set! threads-runnable (remq! t threads-runnable))
	 (set! threads-eoi (remq! t threads-eoi)))))

;*---------------------------------------------------------------------*/
;*    thread-add-mutex! ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-add-mutex! t m)
   (with-access::thread t (%mutexes)
      (set! %mutexes (cons t %mutexes))))

;*---------------------------------------------------------------------*/
;*    thread-del-mutex! ...                                            */
;*---------------------------------------------------------------------*/
(define (thread-del-mutex! t m)
   (with-access::thread t (%mutexes)
      (set! %mutexes (remq! t %mutexes))))
