;*=====================================================================*/
;*    serrano/prgm/project/bigloo/fthread/src/Llib/fair-socket.scm     */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed Feb 13 09:42:47 2002                          */
;*    Last change :  Thu Jun 26 14:48:47 2003 (serrano)                */
;*    Copyright   :  2002-03 Manuel Serrano                            */
;*    -------------------------------------------------------------    */
;*    Fair sockets, that is non blocking socket connection.            */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __ft_socket

    (import __ft_types
	    __ft_scheduler
	    __ft_%thread)

   (export (make-fair-socket ::socket)
	   (make-fair-accept-socket ::socket)))

;*---------------------------------------------------------------------*/
;*    make-fair-socket ...                                             */
;*---------------------------------------------------------------------*/
(define (make-fair-socket socket)
   (lambda (scdl event)
      (socket-accept-connection socket #t)
      (scheduler-broadcast! scdl event)))

;*---------------------------------------------------------------------*/
;*    make-fair-accept-socket ...                                      */
;*---------------------------------------------------------------------*/
(define (make-fair-accept-socket socket)
   (lambda (scdl event)
      (scheduler-broadcast! scdl event (socket-accept socket #t #f))))
