;*=====================================================================*/
;*    serrano/prgm/project/bigloo/fthread/src/Llib/fair-writer.scm     */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Jul 11 10:22:38 2002                          */
;*    Last change :  Wed May 14 20:53:13 2003 (serrano)                */
;*    Copyright   :  2002-03 Manuel Serrano                            */
;*    -------------------------------------------------------------    */
;*    Fair writers, i.e., cooperative writers.                         */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __ft_writer
   
   (import __ft_types
	   __ft_scheduler
	   __ft_%thread)

   (export (make-fair-writer ::output-port ::bstring)))

;*---------------------------------------------------------------------*/
;*    make-fair-writer ...                                             */
;*    -------------------------------------------------------------    */
;*    A fair thread asks WRITER-AWAIT to be notified when N chars      */
;*    written on PORT. When this condition is meet, the event EVENT    */
;*    is signaled.                                                     */
;*---------------------------------------------------------------------*/
(define (make-fair-writer port str)
   (lambda (scdl event)
      (let ((v (%bgl-asynchronous-thunk-print str port)))
	 (scheduler-broadcast! scdl event v))))

